/*
 * Copyright (C) 2005-2006 by egnite Software GmbH
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * For additional information see http://jtagomat.sourceforge.net/
 */
#include "flash.h"

static unsigned long FlashWaitReady(flashptr_t addr, flashdat_t data)
{
    volatile long tmo = 0x1000000;

    while(*addr != data) {
        if (--tmo <= 0) {
            return 1;
        }
    }
    return 0;
}

unsigned long FlashIdentifier(flashptr_t base)
{
    unsigned long id;

    base[0x555] = 0xAA;
    base[0xAAA] = 0x55;
    base[0x555] = 0x90;
    id = base[0];
    id <<= 16;
    id |= base[1];
    base[0x555] = 0xAA;
    base[0xAAA] = 0x55;
    base[0x555] = 0xF0;

    return id;
}

unsigned long FlashEraseSector(flashptr_t base, flashptr_t addr)
{
    base[0x555] = 0xAA;
    base[0xAAA] = 0x55;
    base[0x555] = 0x80;
    base[0x555] = 0xAA;
    base[0xAAA] = 0x55;
    *addr = 0x30;

    return FlashWaitReady(addr, (flashdat_t)-1);
}

unsigned long FlashWrite(flashptr_t base, flashptr_t addr, flashdat_t data)
{
    base[0x555] = 0xAA;
    base[0xAAA] = 0x55;
    base[0x555] = 0xA0;
    *addr = data;

    return FlashWaitReady(addr, data);
}
